"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get = _interopRequireDefault(require("lodash/get"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = ({
  values,
  rules,
  errors = [],
  setErrors,
  valuesBlurred
}) => {
  let newErrors = Object.keys(rules).filter(rule => {
    if (errors.filter(error => error.name === rule).length) return true;
    if (valuesBlurred) return valuesBlurred[rule];
    return true;
  }).map(field => rules[field].map(rule => {
    let error = rule((0, _get.default)(values, field), values);
    if (!error) return false;
    return {
      name: field,
      message: error
    };
  })).reduce((acc, row) => [...acc, ...row], []).filter(Boolean);
  setErrors(newErrors);
  return newErrors;
};

exports.default = _default;